﻿Imports System.Text
Imports System.Threading.Tasks

Namespace SplitAndMerge
  Public Class Constants
	Public Const START_ARG As Char = "("c
	Public Const END_ARG As Char = ")"c
	Public Const END_LINE As Char = ControlChars.Lf
	Public Const NEXT_ARG As Char = ","c
	Public Const QUOTE As Char = """"c
	Public Const START_GROUP As Char = "{"c
	Public Const END_GROUP As Char = "}"c
	Public Const END_STATEMENT As Char = ";"c
	Public Const VAR_PREFIX As Char = "$"c

	Public Const [IF] As String = "if"
	Public Const [ELSE] As String = "else"
	Public Const ELSE_IF As String = "elif"
	Public Const [WHILE] As String = "while"
	Public Const BREAK As String = "break"
	Public Const [CONTINUE] As String = "continue"
	Public Const COMMENT As String = "//"

	Public Const ABS As String = "abs"
	Public Const APPEND As String = "append"
	Public Const CD As String = "cd"
	Public Const CD__ As String = "cd.."
	Public Const DIR As String = "dir"
	Public Const ENV As String = "env"
	Public Const EXP As String = "exp"
	Public Const FINDFILES As String = "findfiles"
	Public Const FINDSTR As String = "findstr"
	Public Const INDEX_OF As String = "indexof"
	Public Const KILL As String = "kill"
	Public Const PI As String = "pi"
	Public Const POW As String = "pow"
	Public Const PRINT As String = "print"
	Public Const PSINFO As String = "psinfo"
	Public Const PSTIME As String = "pstime"
	Public Const PWD As String = "pwd"
	Public Const RUN As String = "run"
	Public Const SETENV As String = "setenv"
	Public Const [SET] As String = "set"
	Public Const SIN As String = "sin"
	Public Const SIZE As String = "size"
	Public Const SQRT As String = "sqrt"
	Public Const SUBSTR As String = "substr"
	Public Const TOLOWER As String = "tolower"
	Public Const TOUPPER As String = "toupper"

	Public Shared NEXT_ARG_ARRAY() As Char = NEXT_ARG.ToString().ToCharArray()
	Public Shared END_ARG_ARRAY() As Char = END_ARG.ToString().ToCharArray()
	Public Shared END_LINE_ARRAY() As Char = END_LINE.ToString().ToCharArray()
	Public Shared QUOTE_ARRAY() As Char = QUOTE.ToString().ToCharArray()

	Public Shared COMPARE_ARRAY() As Char = "<>=)".ToCharArray()
	Public Shared IF_ARG_ARRAY() As Char = "&|)".ToCharArray()
        Public Shared END_PARSE_ARRAY() As Char = (";)}" & vbLf).ToCharArray()
	Public Shared NEXT_OR_END_ARRAY() As Char = { NEXT_ARG, END_ARG, END_STATEMENT }

	Public Shared TOKEN_SEPARATION() As Char = ("<>=+-*/&^|!" & vbLf & vbTab & " " & AscW(START_ARG) + AscW(END_ARG) + AscW(START_GROUP) + AscW(NEXT_ARG) + AscW(END_STATEMENT)).ToCharArray()

  End Class
End Namespace
